/*
   Marcelo Torres, Noviembre de 2006.
   TActivex para [x]Harbour Minigui.
   Adaptacion del trabajo de:
   ---------------------------------------------
   Lira Lira Oscar Joel [oSkAr]
   Clase TAxtiveX_FreeWin para Fivewin
   Noviembre 8 del 2006
   email: oscarlira78@hotmail.com
   http://freewin.sytes.net
   @CopyRight 2006 Todos los Derechos Reservados
   ---------------------------------------------
*/

#include "minigui.ch"
#include "hbclass.ch"

Static oWActiveX
Static oActiveX

FUNCTION Main()
   PRIVATE bVerde := .T.
   DEFINE WINDOW WinDemo ;
      AT 118,73 ;
      WIDTH 808 ;
      HEIGHT 534 ;
      TITLE 'QAC Sample for Minigui ActiveX Support' ;
      ICON '' ;
      MAIN ;
      ON INIT fOpenActivex() ;
      ON RELEASE fCloseActivex() ;
      ON SIZE Ajust() ;
      ON MAXIMIZE Ajust() ;
      BACKCOLOR {236 , 233 , 216 } ;
      FONT 'Verdana' ;
      SIZE 10 ;

      @ GetProperty( "WinDemo" , "height" ) - 60 , 10 LABEL LSemaforo ;
         VALUE " " ;
         WIDTH 27 ;
         HEIGHT 27 ;
         FONTCOLOR {0,255,0} ;
         BACKCOLOR {0,255,0}

      @ GetProperty( "WinDemo" , "height" ) - 57 , 43 TEXTBOX URL_ToNavigate ;
         HEIGHT 23 ;
         WIDTH GetProperty( "WinDemo" , "width" ) - 165 ;
         Font 'Verdana' ;
         ON ENTER Navegar() ;

      @ GetProperty( "WinDemo" , "height" ) - 60 , GetProperty( "WinDemo" , "width" ) - 115 BUTTON BNavigate ;
         CAPTION 'Navigate' ;
         ACTION Navegar() ;
         WIDTH 100 ;
         HEIGHT 28 ;
         FONT 'Verdana' ;

      DEFINE TIMER TSemaforo ;
         INTERVAL    1000 ;
         ACTION SwitchSemaforo() ;

   END WINDOW

   Center window WinDemo

   Activate window WinDemo

RETURN NIL

Static Procedure fOpenActivex()
   oWActiveX := TActiveX():New( "WinDemo", "Shell.Explorer.2" , 0 , 0 , GetProperty( "WinDemo" , "width" ) - 07 , GetProperty( "WinDemo" , "height" ) - 72 )
   oActiveX := oWActiveX:Load()
   oActiveX:Navigate( "www.google.com.ar" )
Return

Static Procedure fCloseActivex()
   oWActivex := Nil
   oActivex := Nil
Return

Function SwitchSemaforo()
   if oActiveX:Busy()
      if bVerde
         bVerde := .F.
         WinDemo.LSemaforo.BackColor := {255,0,0}
      endif
   else
      if !bVerde
         bVerde := .T.
         WinDemo.LSemaforo.BackColor := {0,255,0}
         SetProperty( "WinDemo" , "URL_ToNavigate" , "value" , oActiveX:LocationURL() )
      endif
   endif
Return

Function Navegar()
   oActiveX:Navigate( GetProperty( "WinDemo" , "URL_ToNavigate" , "value" ) )
Return

Function Ajust()
   SetProperty( "WinDemo" , "LSemaforo" , "row" , GetProperty( "WinDemo" , "height" ) - 60 )
   SetProperty( "WinDemo" , "URL_ToNavigate" , "row" , GetProperty( "WinDemo" , "height" ) - 57 )
   SetProperty( "WinDemo" , "URL_ToNavigate" , "width" , GetProperty( "WinDemo" , "width" ) - 165 )
   SetProperty( "WinDemo" , "BNavigate" , "row" , GetProperty( "WinDemo" , "height" ) - 60 )
   SetProperty( "WinDemo" , "BNavigate" , "col" , GetProperty( "WinDemo" , "width" ) - 115 )
// oWActiveX:ReSize( 0 , 0 , GetProperty( "WinDemo" , "width" ) - 07 , GetProperty( "WinDemo" , "height" ) - 72 )
   oWActiveX:Ajust()
Return
